unit U_Print_GUI;
{ Credits:
  this is a remake of the examples made by Jitendra Gouda
  http://delphiprogrammingdiary.blogspot.com/2019/03/customized-printing-in-delphi.html
  His Blog : http://delphiprogrammingdiary.blogspot.com/

  Detlef Overbeek: I have interpreted his ideas because it is a very helpfull website.}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ComCtrls, Printers,
  Vcl.ExtDlgs, Vcl.ExtCtrls, System.ImageList, Vcl.ImgList,
  Vcl.BaseImageCollection, Vcl.ImageCollection;

type
  TfrmPrint = class(TForm)
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    BitBtnPrinterSetup: TBitBtn;
    BitBtnPrint: TBitBtn;
    RichEdit1: TRichEdit;
    BitBtnRichedit: TBitBtn;
    BitBtnPrintImage: TBitBtn;
    BitBtnPrintMemo: TBitBtn;
    Memo1: TMemo;
    BitBtnAddText: TBitBtn;
    OpenTextFileDialog1: TOpenTextFileDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    BitBtnLines_Shapes: TBitBtn;
    listviewEmp: TListView;
    ListViewCity: TListView;
    BitBtnLoadNames: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtnPrintListView: TBitBtn;
    Label1: TLabel;
    procedure BitBtnPrinterSetupClick(Sender: TObject);
    procedure BitBtnPrintClick(Sender: TObject);
    procedure BitBtnRicheditClick(Sender: TObject);
    procedure BitBtnPrintMemoClick(Sender: TObject);
    procedure BitBtnAddTextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtnPrintImageClick(Sender: TObject);
    procedure BitBtnLines_ShapesClick(Sender: TObject);
    procedure BitBtnLoadNamesClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtnPrintListViewClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrint: TfrmPrint;

implementation

////////////////////////////////////////////////////////////////////////////////

{$R *.dfm}

procedure TfrmPrint.FormCreate(Sender: TObject);
begin
  RichEdit1.Clear;
  RichEdit1.SelAttributes.Color := clBlue;
  RichEdit1.SelAttributes.Style := [fsBold];
  RichEdit1.SelText := 'This is bold blue text.';
  RichEdit1.SelAttributes.Color := clRed;
  RichEdit1.SelAttributes.Style := [fsItalic];
  RichEdit1.SelText := #32'This is italic red text';
end;

procedure TfrmPrint.BitBtnPrintMemoClick(Sender: TObject);
var
  rectPage: TRect;
  sText: string;
begin
  if PrintDialog1.Execute then
  begin
    rectPage := Rect(0, 0, Printer.PageWidth, Printer.PageHeight);
    with Printer do
      begin
        BeginDoc;

        sText := memo1.Text;
        //setting font
        Canvas.Font.Name := 'Verdana';
        Canvas.Font.Size := 11;
        Canvas.Font.Color := clBlack;
        //draws the text with wordbreak
        Canvas.TextRect(rectPage, sText, [tfWordBreak]);

        EndDoc;
      end;

    ShowMessage('Printing has been finished.');
  end;

end;

procedure TfrmPrint.BitBtnLoadNamesClick(Sender: TObject);
begin
  with listviewEmp do
  begin
    with Items.Add do
    begin
      Caption := '01';
      SubItems.Add('Mattias Gaertner');
    end;
    with Items.Add do
    begin
      Caption := '02';
      SubItems.Add('Michael van Canneyt');
    end;
    with Items.Add do
    begin
      Caption := '03';
      SubItems.Add('Martin Friebe');
    end;
    with Items.Add do
    begin
      Caption := '04';
      SubItems.Add('Detlef Overbeek');
    end;
    with Items.Add do
    begin
      Caption := '05';
      SubItems.Add('Rik Smit');
    end;
    with Items.Add do
    begin
      Caption := '06';
      SubItems.Add('Emiel Overbeek');
    end;
    with Items.Add do
    begin
      Caption := '07';
      SubItems.Add('Vincent Overbeek');
    end;
    with Items.Add do
    begin
      Caption := '08';
      SubItems.Add('Willy Overbeek');
    end;
    with Items.Add do
    begin
      Caption := '09';
      SubItems.Add('Siegfried Zuhr');
    end;
    with Items.Add do
    begin
      Caption := '10';
      SubItems.Add('Danny Wind');
    end;
  end;
end;

procedure TfrmPrint.BitBtn2Click(Sender: TObject);
//fill city  country data//

begin
  with listviewCity do
  begin
    with Items.Add do
    begin
      Caption := 'Cologne';
      SubItems.Add('Germany');
    end;
    with Items.Add do
    begin
      Caption := 'Leuven';
      SubItems.Add('Belgium');
    end;
    with Items.Add do
    begin
      Caption := 'Mainz';
      SubItems.Add('Germany');
    end;
    with Items.Add do
    begin
      Caption := 'IJsselstein';
      SubItems.Add('Netherlands');
    end;
    with Items.Add do
    begin
      Caption := 'Rotterdam';
      SubItems.Add('Netherlands');
    end;
    with Items.Add do
    begin
      Caption := 'IJsselstein';
      SubItems.Add('Netherlands');
    end;
    with Items.Add do
    begin
      Caption := 'Eindhoven';
      SubItems.Add('Netherlands');
    end;
    with Items.Add do
    begin
      Caption := 'IJsselstein';
      SubItems.Add('Netherlands');
    end;
    with Items.Add do
    begin
      Caption := 'Boskoop';
      SubItems.Add('Netherlands');
    end;
    with Items.Add do
    begin
      Caption := 'Rotterdam';
      SubItems.Add('Netherlands');
    end;
  end;
end;

procedure TfrmPrint.BitBtnAddTextClick(Sender: TObject);
var
  Encoding : TEncoding;
  EncIndex : Integer;
  Filename : String;
begin
  if OpenTextFileDialog1.Execute(Self.Handle) then
    begin
    //Selecting the file name and encoding
    Filename := OpenTextFileDialog1.FileName;

    EncIndex := OpenTextFileDialog1.EncodingIndex;
    Encoding := OpenTextFileDialog1.Encodings.Objects[EncIndex] as TEncoding;

    //Checking if the file exists
    if FileExists(Filename) then
      //Display the contents in a memo based on the selected encoding.
      Memo1.Lines.LoadFromFile(FileName, Encoding)
    else
      raise Exception.Create('File does not exist.');
    end;
end;

procedure TfrmPrint.BitBtnRicheditClick(Sender: TObject);
begin
  if PrintDialog1.Execute then
  begin
    RichEdit1.Print('Print Rich Edit Data');

    ShowMessage('Printing the RichEdit is done.');

  end;
end;

procedure TfrmPrint.BitBtnPrintImageClick(Sender: TObject);
var
  rectPage: TRect;
  image1: TBitmap;
begin
  if PrintDialog1.Execute then
  begin
    rectPage := Rect(0, 0, Printer.PageWidth, Printer.PageHeight);
    with Printer do

    begin
      if OpenPictureDialog1.Execute then
      //start printing
      BeginDoc;

      image1 := TBitmap.Create;
      image1.LoadFromFile(OpenPictureDialog1.FileName);
      Canvas.StretchDraw(Rect(500, 1000, 1500, 2000), image1);
      image1.Free;
      //finish printing
      EndDoc;
    end;
    ShowMessage('Printing the image is done.');
  end;
end;

procedure TfrmPrint.BitBtnPrintClick(Sender: TObject);
begin
  if PrintDialog1.Execute then
  begin
    ShowMessage('Setup Printing is done.');
  end;
end;

procedure TfrmPrint.BitBtnPrinterSetupClick(Sender: TObject);
begin
  if PrinterSetupDialog1.Execute then
  begin
    ShowMessage('The Printer SetUp is done.');
  end;
end;

procedure TfrmPrint.BitBtnLines_ShapesClick(Sender: TObject);
var
  rectPage: TRect;
begin
  if PrintDialog1.Execute then
  begin
    rectPage := Rect(0, 0, Printer.PageWidth, Printer.PageHeight);
    with Printer do
    begin
      //start printing
      BeginDoc;
      Canvas.Pen.Width := 3;
      Canvas.Pen.Color := clBlue;
      Canvas.MoveTo(500, 2200);
      Canvas.LineTo(rectPage.Width-500, 2200);

      Canvas.Brush.Color := clRed;
      Canvas.Rectangle(1000, 2500, 2000, 3500);

      Canvas.Brush.Color := clYellow;
      Canvas.Ellipse(1000, 3000, 2000, 4000);

      //finish printing
      EndDoc;
    end;
  end;
end;

//fill staff + authors member data//


procedure TfrmPrint.BitBtnPrintListViewClick(Sender: TObject);
var
  sText,  sReportHeader: string;
  image1: TBitmap;
  i, iTop: Integer;
begin
  if PrintDialog1.Execute then
  begin
    with Printer do
    begin
      //start printing
      BeginDoc;

      Canvas.Font.Size := 13;
      Canvas.Font.Color := clRed;
      Canvas.Font.Style := [fsBold];

      sReportHeader := 'Members and Authors BPM';
      Canvas.TextOut((Printer.PageWidth-Canvas.TextWidth(sReportHeader)) div 2, 100, sReportHeader);

      Canvas.MoveTo(200, 500);
      Canvas.LineTo(Printer.PageWidth-200, 500);

      Canvas.Font.Size := 12;
      Canvas.Font.Color := clBlue;
      Canvas.Font.Style := [fsBold];

      Canvas.TextOut(400, 600, listviewEmp.Column[0].Caption);
      Canvas.TextOut(1000, 600, listviewEmp.Column[1].Caption);

      Canvas.MoveTo(200, 800);
      Canvas.LineTo(Printer.PageWidth-200, 800);

      Canvas.Font.Size := 10;
      Canvas.Font.Color := clBlack;
      Canvas.Font.Style := [];
      iTop := 900;
      for I := 0 to listviewEmp.Items.Count-1 do
      begin
        Canvas.TextOut(400, iTop, listviewEmp.Items[i].Caption);
        Canvas.TextOut(1000, iTop, listviewEmp.Items[i].SubItems[0]);
        iTop := iTop + 250;
      end;

      iTop := iTop+250;
      Canvas.MoveTo(200, iTop);
      Canvas.LineTo(Printer.PageWidth-200, iTop);

      Canvas.TextOut((Printer.PageWidth-Canvas.TextWidth(sReportHeader)) div 2, iTop + 100, DateToStr(Now)+' - Page:'+IntToStr(PageNumber));

      NewPage;

      Canvas.Font.Size := 15;
      Canvas.Font.Color := clRed;
      Canvas.Font.Style := [fsBold];

      sReportHeader := 'City - Country Details';
      Canvas.TextOut((Printer.PageWidth-Canvas.TextWidth(sReportHeader)) div 2, 100, sReportHeader);

      Canvas.MoveTo(200, 500);
      Canvas.LineTo(Printer.PageWidth-200, 500);

      Canvas.Font.Size := 12;
      Canvas.Font.Color := clBlue;
      Canvas.Font.Style := [fsBold];

      Canvas.TextOut(400, 600, listviewCity.Column[0].Caption);
      Canvas.TextOut(2000, 600, listviewCity.Column[1].Caption);

      Canvas.MoveTo(200, 800);
      Canvas.LineTo(Printer.PageWidth-200, 800);

      Canvas.Font.Size := 10;
      Canvas.Font.Color := clBlack;
      Canvas.Font.Style := [];
      iTop := 900;

      for I := 0 to listviewCity.Items.Count-1 do
      begin
        Canvas.TextOut(400, iTop, listviewCity.Items[i].Caption);
        Canvas.TextOut(2000, iTop, listviewCity.Items[i].SubItems[0]);
        iTop := iTop + 250;
      end;

      iTop := iTop+250;
      Canvas.MoveTo(200, iTop);
      Canvas.LineTo(Printer.PageWidth-200, iTop);

      Canvas.TextOut((Printer.PageWidth-Canvas.TextWidth(sReportHeader)) div 2, iTop + 100, DateToStr(Now)+' - Page:'+IntToStr(PageNumber));

      //finish printing
      EndDoc;
    end;

    ShowMessage('Printing is done.');
  end;
end;


end.
